# 1.1.1 Hello，Python

## Python为何物？

说出来您可能不信，现在大名鼎鼎的编程语言 Python 是由 Guido van Rossum 在 1989 年圣诞节期间，为了打发无聊的圣诞节而编写的一个编程语言。而也正是因为作者的无聊，我们现在才得以使用风靡全球的编程语言 Python 。(无聊是个好东西)

Python 为什么这么流行呢？主要原因有两个：

- 首先是因为本身语法简单，而且提供了非常完善的基础代码库，覆盖了如网络、文件、GUI、数据库、正则表达式等大量内容。您可别小看了这些基础代码库，它会让我们在实现功能时减少我们的代码量，将我们从底层代码中解放出来，更加的关心我们需要实现的业务功能。
- 其次是大家觉得 Python 这么好用，就会有很多具有开源精神的开发者去开发各种各样的第三方模块。接着大家可能会去尝试使用这些模块，然后发现这些模块挺好用的，然后就可能会把这些好用的模块或者 Python 语言推荐给自己的朋友、同事。就这样，不断地完善了 Python 的生态。以前用 C 语言想要实现一个功能可能需要 30 行代码，而用 Python 可能只需要 1 行代码。这也就使得编程的门槛越来越低，越来越流行。

事物都有两面性，既然 Python 有这么大的优点，那肯定也有不小的缺点。 Python 最为致命的确定就是运行速度慢。由于 Python 是解释型语言，您所编写的代码在执行时，解释器会一行一行的翻译成 CPU 能理解的机器码，这个翻译过程是非常耗时的，所以 Python 的运行速度很慢。而像 C 语言所编写的程序在运行前会直接将代码翻译成 CPU 能够理解的机器码，所以 C 语言编写的程序运行时非常快。

不过值得庆幸的是，大量的应用程序不需要这么快的运行速度，因为用户根本感觉不出来。例如开发一个下载 短视频 的网络应用程序，C 程序的运行时间需要0.001 秒，而 Python 程序的运行时间需要 0.1 秒，慢了 100 倍，但由于网络更慢，需要等待 5 秒。您可以思考一下，用户真的能感觉到 5.001 秒和 5.1秒 的区别吗？

这就好比布加迪威龙和五菱宏光在北京三环路上行驶的道理一样，虽然理论时速高达 430 公里，但由于三环路堵车的时速只有 20 公里，因此，作为乘客，您感觉的时速是 20 公里。

所以选择 Python 作为编程语言是一种比较明智的选额。

## 如何安装Python？

相信现在您可能已经迫不及待地想要在自己的机器上安装 Python 并开始 Python 之旅了。不过在安装 Python 前还需要了解一个知识，就是 Python 其实有两个不兼容的版本，一个是 2.x 版，另一个是 3.x 版。但由于 2.x 版只维护到 2020 年，而且 Python 官方都直接建议直接使用 3.x 版。所以在这里建议您安装最新的Python 3.7 版。

想要安装 Python 3.7 可以 Python 官网([https://www.python.org/downloads/](https://www.python.org/downloads/))根据您机器的操作系统的类型下载对应的安装程序，然后运行安装即可。

![1](1.jpg)

## 喜闻乐见的Hello，World

一般在学编程时都先学着写一个 “Hello，World” 来表征一下自己的已经开始了编程之旅。那么我们来看一下怎样写 Python 版的 “Hello，World” 。(本书使用的操作系统是 Windows )

首先在自己喜欢的一个目录中创建一个文本文件，并在文件中输入如下代码：

```python
print('Hello, World')
```

然后修改文件的名字，如 first.py。**(注意：Python 代码文件的后缀名为 py )**

接着进入命令行，进入到 first.py 所在的目录。例如 first.py 在 D:/code 目录下，所以需要在命令行输入：

```shell
cd d:/code
```

最后只要在命令行输入如下命令就可以运行我们写好的程序了。

```shell
python first.py
```

运行程序后看到的输出和我们的预期一致。

```python
Hello, World
```

