# 4.1.4：直方图

## 什么是直方图
单从外表上看直方图和条形图非常相似。首先需要区分清楚概念：直方图和条形图。


- 条形图用长条形表示每一个类别，长条形的长度表示类别的频数，宽度表示表示类别。

- 直方图是一种统计报告图，形式上也是一个个的长条形，但是直方图用长条形的面积表示频数，所以长条形的高度表示频数组距，宽度表示组距，其长度和宽度均有意义。当宽度相同时，一般就用长条形长度表示频数。


## 绘制直方图
直方图一般用来描述等距数据。直观上，直方图各个长条形是衔接在一起的，表示数据间的数学关系。
```python
import matplotlib.pyplot as plt
import numpy as np
import matplotlib

# 设置matplotlib正常显示中文和负号
matplotlib.rcParams['font.sans-serif']=['SimHei']   # 用黑体显示中文
matplotlib.rcParams['axes.unicode_minus']=False     # 正常显示负号
# 随机生成（10000,）服从正态分布的数据
data = np.random.randn(10000)
plt.hist(data,bins=30, normed=0, facecolor="red", alpha=0.7)
# 显示横轴标签
plt.xlabel("区间")
# 显示纵轴标签
plt.ylabel("频数/频率")
# 显示图标题
plt.title("频数/频率分布直方图")

```

![](17.jpg)

|  参数 |  作用 |
| :------------: | :------------: |
| data  |必选参数，绘图数据   |
|bins   |直方图的长条形数目，可选项，默认为10   |
|normed|是否将得到的直方图向量归一化，可选项，默认为0，代表不归一化，显示频数。normed=1，表示归一化，显示频率。|
|facecolor|长条形的颜色|
|edgecolor|长条形边框的颜色|
|alpha|透明度|

